'use strict';

exports.__esModule = true;
exports.param = param;
exports.buildUrl = buildUrl;
function param(a) {
    return Object.keys(a).map(function (k) {
        return encodeURIComponent(k) + '=' + encodeURIComponent(a[k]);
    }).join('&');
}

function buildUrl(url, query) {
    return url + (query ? "?" + param(query) : "");
}