"use strict";

exports.__esModule = true;
exports.getAMPM = getAMPM;
var isAfter = exports.isAfter = require("date-fns/is_after");
var isBefore = exports.isBefore = require("date-fns/is_before");
var isEqual = exports.isEqual = require("date-fns/is_equal");
var max = exports.max = require("date-fns/max");
var min = exports.min = require("date-fns/min");
var parse = exports.parse = require("date-fns/parse");
var getTime = exports.getTime = require("date-fns/get_time");
var isThisHour = exports.isThisHour = require("date-fns/is_this_hour");
var isThisQuarter = exports.isThisQuarter = require("date-fns/is_this_quarter");
var isThisWeek = exports.isThisWeek = require("date-fns/is_this_week");
var isThisMonth = exports.isThisMonth = require("date-fns/is_this_month");
var isThisYear = exports.isThisYear = require("date-fns/is_this_year");
var format = exports.format = require("date-fns/format");
function getAMPM(date) {
    var pm = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'pm';
    var am = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'am';

    var hours = date.getHours();
    var minutes = date.getMinutes();
    var ampm = hours >= 12 ? pm : am;
    return ampm;
}