"use strict";

exports.__esModule = true;
exports.mPage = mPage;

var _mixin = require("./mixin");

var _object = require("../object");

function bindAttached(self, options) {}

function bindDetached(self, options) {}

function mPage(mix) {
    var explode = ['onLoad', 'unLoad'];
    var _s = {};
    _s.data = Object.assign({}, _s, (0, _object.omitByKeys)(mix.data, explode));
    _s = Object.assign({}, _s, (0, _object.omitByKeys)(mix.properties, explode));
    _s = Object.assign({}, _s, (0, _object.omitByKeys)(mix.methods, explode));
    _s = Object.assign({}, _s, (0, _object.omitByKeys)(mix.exports, explode));
    _s = Object.assign({}, _s, (0, _object.omitByKeys)(Object.getPrototypeOf(mix), ['constructor'].concat(explode)));

    if (mix && mix.mixins) {
        mix.mixins.forEach(function (mixinkey) {
            var _mix = (0, _mixin.getMixin)(mixinkey) || {};
            _s.data = Object.assign({}, _s, _mix.data);
            _s = Object.assign({}, _s, _mix.properties);
            _s = Object.assign({}, _s, _mix.methods);
        });
    }

    var def = Object.assign(_s, {
        onLoad: function onLoad() {
            var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var self = this;
            self.$opt = options;
            bindAttached.apply(undefined, [self].concat(options));
            mix.exports.onLoad && mix.exports.onLoad.apply(this, options);
        },
        unLoad: function unLoad() {
            var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

            var self = this;
            bindDetached.apply(undefined, [self].concat(options));
            mix.exports.unLoad && mix.exports.unLoad.apply(this, options);
        }
    });

    Page(def);
}