"use strict";

exports.__esModule = true;
/** 
 * 检测浏览器是否在safari里
 */
var isSafari = exports.isSafari = function isSafari() {
  return !!navigator.userAgent.match(/safari/i) && !navigator.userAgent.match(/chrome/i) && typeof document.body.style.webkitFilter !== "undefined" && !window.chrome;
};

/** 
 * 屏幕的大小
 */
var detectMediaMatches = exports.detectMediaMatches = function detectMediaMatches(mediaquery) {
  return window.matchMeda && window.matchMeda(mediaquery).matches;
};

/** 
 * userAgent 像 weixin
 */
var isLikeWeixin = exports.isLikeWeixin = function isLikeWeixin() {
  return (/micromessenger/.test(navigator.userAgent.toLowerCase())
  );
};