"use strict";

exports.__esModule = true;
exports.Error = exports.logger = exports.debug = exports.validate = exports.cast = exports.utils = undefined;

var _error = require("./error");

var _utils2 = require("./utils");

var _utils = _interopRequireWildcard(_utils2);

var _cast2 = require("./cast");

var _cast = _interopRequireWildcard(_cast2);

var _index = require("./validate/index");

var _logger = require("./logger");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

var utils = exports.utils = _utils;
var cast = exports.cast = _cast;

_index._validate.isNil = function (value) {
    return value === undefined || value === null;
};
var validate = exports.validate = _index._validate;
var debug = exports.debug = false;
var logger = exports.logger = (0, _logger.createLogger)();
var Error = exports.Error = _error.ExtendableError;