/** 
 * 检测浏览器是否在safari里
 */
export let isSafari = function() {
    return !!navigator.userAgent.match(/safari/i) && !navigator.userAgent.match(/chrome/i) && typeof document.body.style.webkitFilter !== "undefined" && !window.chrome;
}

/** 
 * 屏幕的大小
 */
export let detectMediaMatches = function(mediaquery) {
    return window.matchMeda && window.matchMeda(mediaquery).matches;
}


/** 
 * userAgent 像 weixin
 */
export let isLikeWeixin = function () {
    return /micromessenger/.test(navigator.userAgent.toLowerCase());
}